﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kokomo.Environment.Services
{
	/// <summary>
	/// Specifies options for showing a dialog box for a file operation (Open or Save As).
	/// </summary>
	public class FileDialogOptions
	{
		/// <summary>
		/// Gets or sets the list of <see cref="FileType"/>s the user may open.
		/// </summary>
		public IList<FileType> FileTypes { get; set; }
		/// <summary>
		/// Gets or sets the title of the dialog box.
		/// </summary>
		public UiString Title { get; set; }
		/// <summary>
		/// Gets or sets a value that specifies whether the user may select multiple files (Open dialog only).
		/// </summary>
		public bool AllowMultiple { get; set; }
		/// <summary>
		/// Gets or sets the <see cref="FileType"/> selected by the user.
		/// </summary>
		public FileType SelectedFileType { get; set; }

		/// <summary>
		/// Gets or sets the initial directory to show in the dialog.
		/// </summary>
		public string InitialDirectory { get; set; }
		/// <summary>
		/// Gets or sets the initial file name.
		/// </summary>
		public string InitialFileName { get; set; }
	}
}
