﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace Kokomo.Environment.Services
{
	/// <summary>
	/// Provides services for managing <see cref="DocumentTemplate"/>s.
	/// </summary>
	/// <remarks>
	/// The environment provides an implementation of this interface,
	/// and can be retrieved via <see cref="EnvironmentServices"/>.
	/// <para>
	/// See the remarks on <see cref="DelegatedDocumentTemplate"/> for
	/// instructions on providing document templates using composition.
	/// </para>
	/// </remarks>
	public interface IDocumentTemplateManager
	{
		/// <summary>
		/// Gets a collection of <see cref="DocumentTemplate"/>s.
		/// </summary>
		ObservableCollection<DocumentTemplate> Templates { get; }
	}
}
