﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kokomo.Environment.Services
{
	/// <summary>
	/// Specifies keys for standard images provided by the environment.
	/// </summary>
	/// <see cref="IImageProvider"/>
	public static class StandardImageKeys
	{
		#region File
		/// <summary>
		/// Identifies the image for the <c>New Document</c> command.
		/// </summary>
		public static readonly string NewDocument = "NewDocument";
		/// <summary>
		/// Identifies the image for the <c>Open Document</c> command.
		/// </summary>
		public static readonly string OpenDocument = "OpenDocument";
		/// <summary>
		/// Identifies the image for the <c>Save Document</c> command.
		/// </summary>
		public static readonly string SaveDocument = "SaveDocument";
		/// <summary>
		/// Identifies the image for the <c>Save All Documents</c> command.
		/// </summary>
		public static readonly string SaveAllDocuments = "SaveAllDocuments";
		#endregion
		#region Edit
		/// <summary>
		/// Identifies the image for the <c>Cut</c> command.
		/// </summary>
		public static readonly string Cut = "Cut";
		/// <summary>
		/// Identifies the image for the <c>Copy</c> command.
		/// </summary>
		public static readonly string Copy = "Copy";
		/// <summary>
		/// Identifies the image for the <c>Paste</c> command.
		/// </summary>
		public static readonly string Paste = "Paste";
		#endregion
		#region Navigation
		/// <summary>
		/// Go Back (navigation)
		/// </summary>
		public static readonly string Back = "back";
		/// <summary>
		/// Go Forward (navigation)
		/// </summary>
		public static readonly string Forward = "forward";
		/// <summary>
		/// New windom
		/// </summary>
		public static readonly string NewWindow = "NewWindow";
		#endregion
		#region Help
		/// <summary>
		/// Identifies the help icon.
		/// </summary>
		public static readonly string Help = "help";
		#endregion
	}
}
