﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kokomo.Mirror.CliMetadata
{
	class CliByRefType : CliSyntheticType
	{
		private Type _elementType;

		internal CliByRefType(
			CliMemberBasicInfo basicInfo,
			Type elementType
			)
			: base(basicInfo, elementType)
		{
			this._elementType = elementType;
		}

		public override string Name
		{
			get { return this._elementType.Name + "&"; }
		}
		protected override bool IsByRefImpl()
		{
			return true;
		}
		public override Type Reflect()
		{
			return this._elementType.Reflect().MakeByRefType();
		}
	}
}
