﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kokomo.Mirror.CliMetadata.Signatures
{
	public class MalformedSignatureException : Exception
	{
		public MalformedSignatureException(
			byte[] signatureData,
			int offset
			)
			: base("Malformed signature")
		{
			if (signatureData == null) throw new ArgumentNullException("signatureData");

			this.SignatureData = signatureData;
			this.Offset = offset;
		}

		public byte[] SignatureData { get; private set; }
		public int Offset { get; private set; }
	}
}
