﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kokomo.PeInspector
{
	/// <summary>
	/// Specifies keys for images used in disassembly views.
	/// </summary>
	public static class ImageKeys
	{
		/// <summary>
		/// Identifies the C# source code icon.
		/// </summary>
		public static readonly string CSharpCode = "csharp_code";
		/// <summary>
		/// Identifies the MSIL source code icon.
		/// </summary>
		public static readonly string MsilCode = "msil_code";
		/// <summary>
		/// Identifies the assembly references icon.
		/// </summary>
		public static readonly string AssemblyReferences = "assembly";

		/// <summary>
		/// Identifies the XAML source icon.
		/// </summary>
		public static readonly string Xaml = "xaml";
		/// <summary>
		/// String
		/// </summary>
		public static readonly string String = "string";
		/// <summary>
		/// String
		/// </summary>
		public static readonly string Symbols = "symbols";
		/// <summary>
		/// String
		/// </summary>
		public static readonly string Symbol = "Symbol";

		/// <summary>
		/// Sections
		/// </summary>
		public static readonly string Sections = "sections";
		/// <summary>
		/// Section
		/// </summary>
		public static readonly string Section = "section";
		/// <summary>
		/// Table
		/// </summary>
		public static readonly string Table = "TableHS";
	}
}
