﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kokomo.PeInspector.Reflection
{
	/// <summary>
	/// Represents a reference to an assembly member.
	/// </summary>
	public class AssemblyMemberRef
	{
		/// <summary>
		/// Gets or sets the display name of the assembly containing the member.
		/// </summary>
		public string AssemblyDisplayName { get; set; }
		/// <summary>
		/// Gets or sets the metadata token of the member,
		/// or <c>null</c> to signify the containing assembly.
		/// </summary>
		public int? MemberToken { get; set; }
	}
}
