﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kokomo.PeInspector.Reflection
{
	/// <summary>
	/// Specifies the kind of type declaration.
	/// </summary>
	public enum TypeKind
	{
		/// <summary>
		/// Class (reference type)
		/// </summary>
		Class,
		/// <summary>
		/// Structure (value type)
		/// </summary>
		Structure,
		/// <summary>
		/// Interface
		/// </summary>
		Interface,
		/// <summary>
		/// Derives from <see cref="Delegate"/>.
		/// </summary>
		Delegate,
		/// <summary>
		/// Derives from <see cref="Enum"/>.
		/// </summary>
		Enumeration
	}
}
