﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace Kokomo.PeInspector.Reflection
{
	class TypeMemberItem
	{
		public MemberInfo Member { get; private set; }
		public MemberViewInfo ViewInfo { get; private set; }

		public string MemberName { get { return this.Member.Name; } }
		public string MemberType { get { return this.Member.MemberType.ToString(); } }

		public TypeMemberItem(
			MemberInfo member,
			MemberViewInfo viewInfo
			)
		{
			if (member == null) throw new ArgumentNullException("member");

			this.Member = member;
			this.ViewInfo = viewInfo;
		}
	}
}
