﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;

namespace Kokomo.PeInspector
{
	public class SearchView : ContentControl
	{
		static SearchView()
		{
			DefaultStyleKeyProperty.OverrideMetadata(typeof(SearchView), new FrameworkPropertyMetadata(typeof(SearchView)));
		}

		public string SearchTerm
		{
			get { return (string)GetValue(SearchTermProperty); }
			set { SetValue(SearchTermProperty, value); }
		}

		// Using a DependencyProperty as the backing store for SearchTerm.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty SearchTermProperty =
			DependencyProperty.Register("SearchTerm", typeof(string), typeof(SearchView), new FrameworkPropertyMetadata(null, FrameworkPropertyMetadataOptions.BindsTwoWayByDefault));



		public bool IsSearching
		{
			get { return (bool)GetValue(IsSearchingProperty); }
			set { SetValue(IsSearchingProperty, value); }
		}

		// Using a DependencyProperty as the backing store for IsSearching.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty IsSearchingProperty =
			DependencyProperty.Register("IsSearching", typeof(bool), typeof(SearchView), new UIPropertyMetadata(false));




		public ProgressInfo SearchProgress
		{
			get { return (ProgressInfo)GetValue(SearchProgressProperty); }
			set { SetValue(SearchProgressProperty, value); }
		}

		// Using a DependencyProperty as the backing store for SearchProgress.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty SearchProgressProperty =
			DependencyProperty.Register("SearchProgress", typeof(ProgressInfo), typeof(SearchView), new UIPropertyMetadata(null));


	}
}
