﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using System.Windows.Input;

namespace Kokomo.Controls
{
	public class EnhancedListView : ListView
	{
		static EnhancedListView()
		{
			DefaultStyleKeyProperty.OverrideMetadata(typeof(EnhancedListView), new FrameworkPropertyMetadata(typeof(EnhancedListView)));
		}

		public ICommand ItemActivatedCommand
		{
			get { return (ICommand)GetValue(ItemActivatedCommandProperty); }
			set { SetValue(ItemActivatedCommandProperty, value); }
		}

		// Using a DependencyProperty as the backing store for ItemActivatedCommand.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty ItemActivatedCommandProperty =
			DependencyProperty.Register("ItemActivatedCommand", typeof(ICommand), typeof(EnhancedListView), new UIPropertyMetadata(null));


	}
}
