﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;

namespace Kokomo.Controls
{
	public class ToolRegion : FrameworkElement
	{


		public Orientation Orientation
		{
			get { return (Orientation)GetValue(OrientationProperty); }
			internal set { SetValue(OrientationProperty, value); }
		}

		// Using a DependencyProperty as the backing store for Orientation.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty OrientationProperty =
			DependencyProperty.Register("Orientation", typeof(Orientation), typeof(ToolRegion), new UIPropertyMetadata(Orientation.Horizontal));



		public double Size
		{
			get { return (double)GetValue(SizeProperty); }
			set { SetValue(SizeProperty, value); }
		}

		// Using a DependencyProperty as the backing store for Size.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty SizeProperty =
			DependencyProperty.Register("Size", typeof(double), typeof(ToolRegion), new UIPropertyMetadata(0.0));

		public Dock Dock
		{
			get { return (Dock)GetValue(DockProperty); }
			set { SetValue(DockProperty, value); }
		}

		// Using a DependencyProperty as the backing store for Dock.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty DockProperty =
			DependencyProperty.Register("Dock", typeof(Dock), typeof(ToolRegion), new UIPropertyMetadata(Dock.Left));
	}
}
